#include <cmath>
#include <iostream>
#include <vector>
using namespace std;

double best[2][20000];
unsigned how[20000][1260];

int main() {
    int L, S, A, B;
    cin >> L >> S >> A >> B;

    vector<int> acka(A), becka(B);
    for (int &x:acka) cin >> x;
    for (int &x:becka) cin >> x;

    for (int a=0; a<A; ++a) {
        int cur=a%2, prev=1-cur;

        for (int b=0; b<B; ++b) {
            double   bestopt = 1e30;
            double   cdist   = sqrt(1.*(acka[a]-becka[b])*(acka[a]-becka[b]) + S*S);
            unsigned besthow = 0;

            if (a==0 && b==0)                            { bestopt=0;               besthow=0; }
            if (a>0 && best[prev][b] < bestopt)          { bestopt=best[prev][b];   besthow=1; }
            if (b>0 && best[cur][b-1] < bestopt)         { bestopt=best[cur][b-1];  besthow=2; }
            if (a>0 && b>0 && best[prev][b-1] < bestopt) { bestopt=best[prev][b-1]; besthow=3; }
            best[cur][b] = cdist + bestopt;
            how[a][b/16] |= besthow << ((b&15)<<1);
        }
    }
    
    int a=A-1, b=B-1, step;
    vector< pair<int,int> > answer;
    do {
        answer.push_back({a+1,b+1}); 
        step = (how[a][b/16] >> ((b&15)<<1)) & 3;
        a -= step&1;
        b -= step>>1;
    } while (step);

    cout << answer.size() << "\n";
    for (auto e:answer) cout << e.first << " " << e.second << "\n";
}
